#include <SpaceOrb.h>

/* This demo uses the SpaceOrb.h library, a library based on AVRUSB from ObDev
 * It demonstrates a 6-axis joystick with 4 buttons by reading all the analog ports and
 * digtal pins 9,10,11,and 12
 * Adapted from the UsbKeyboard.h library from Phil Lindsay
 *
 * by Michel Gutlich   19-8-2008
 */


#include "orb_buffer.h"
OrbBuffer orb_buffer;
byte inc_byte;

void setup() {
  Serial.begin( 9600 );
}

void loop () {
  SpaceOrb.refresh(); // Let the AVRUSB driver do some houskeeping
  if ( Serial.available() > 0 )
  {
    inc_byte = Serial.read();
    orb_buffer.add_byte( inc_byte );
  }
  if ( orb_buffer.has_changed )
  {
    SpaceOrb.sendJoystick( orb_buffer.logical_axes[0],
    orb_buffer.logical_axes[1],
    orb_buffer.logical_axes[2],
    orb_buffer.logical_axes[3],
    orb_buffer.logical_axes[4],
    orb_buffer.logical_axes[5],
    orb_buffer.logical_buttons );
    orb_buffer.log_change();
  }
}

