//Created August 23 2006
//Heather Dewey-Hagborg
//http://www.arduino.cc

#include <ctype.h>
//#include "chart.h"
#include "orb_buffer.h"

byte rx_pin = 10;
byte tx_pin = 11;
byte SWval;
byte pin_power = 12;
byte pin_indicator = 13;
OrbBuffer orb_buffer;

void setup() {
  pinMode(rx_pin,INPUT);
  pinMode(tx_pin,OUTPUT);
  digitalWrite(tx_pin,HIGH);
  digitalWrite(pin_power,HIGH); //turn on debugging LED
  Serial.begin(9600);
  Serial.println("Hello World");
  //SWprint('h');  //debugging hello
  //SWprint('i');
  //SWprint(10); //carriage return
}

void print_buffer_axes( void )
{
  Serial.print( "+++\n");
  Serial.print( orb_buffer.buffer[0], DEC );
  Serial.print( ", " );
  Serial.print( orb_buffer.buffer[1], DEC );
  Serial.print( ", " );
  Serial.print( orb_buffer.buffer[2], DEC );
  Serial.print( ", ");
  Serial.print( orb_buffer.buffer[3], DEC );
  Serial.print( ", ");
  Serial.print( orb_buffer.buffer[4], DEC );
  Serial.print( ", ");
  Serial.print( orb_buffer.buffer[5], DEC );
  Serial.print( ", ");
  Serial.print( orb_buffer.buffer[6], DEC );
  Serial.print( ", ");
  Serial.print( orb_buffer.buffer[7], DEC );
  Serial.print( ", ");
  Serial.print( orb_buffer.buffer[8], DEC );
  Serial.print( ", ");
  Serial.print( orb_buffer.buffer[9], DEC );
  Serial.print( ", ");
  Serial.print( orb_buffer.buffer[10], DEC );
  Serial.print("\n");
  Serial.print( orb_buffer.physical_axes[0], DEC );
  Serial.print(", ");
  Serial.print( orb_buffer.physical_axes[1], DEC );
  Serial.print(", ");
  Serial.print( orb_buffer.physical_axes[2], DEC );
  Serial.print(", ");
  Serial.print( orb_buffer.physical_axes[3], DEC );
  Serial.print(", ");
  Serial.print( orb_buffer.physical_axes[4], DEC );
  Serial.print(", ");
  Serial.print( orb_buffer.physical_axes[5], DEC );
  Serial.print("\n---\n");
}

void print_orb_status(void)
{
  Serial.print( orb_buffer.logical_axes[0],  DEC );
  Serial.print( ", " );
  Serial.print( orb_buffer.logical_axes[1],  DEC );
  Serial.print( ", " );
  Serial.print( orb_buffer.logical_axes[2],  DEC );
  Serial.print( ", " );
  Serial.print( orb_buffer.logical_axes[3],  DEC );
  Serial.print( ", " );
  Serial.print( orb_buffer.logical_axes[4],  DEC );
  Serial.print( ", " );
  Serial.print( orb_buffer.logical_axes[5],  DEC );
  Serial.print( ", [" );
  Serial.print( orb_buffer.logical_buttons, DEC );
  Serial.print( "]\n");
}

void loop()
{
  //Serial.print("Looping\n");
  //SWval = SWread(); 
  if ( Serial.available() > 0 )
  {
    /*unsigned short b = mshl( 213, 0x7f, 3 ) | mshr( 130, 0x70, 4 );
    Serial.print( b, DEC );
    Serial.print("->");
    Serial.print( reshift(b), DEC );
    Serial.print( "\n");*/
    SWval = Serial.read();
    orb_buffer.add_byte( SWval );
    if ( orb_buffer.has_changed )
    {
      switch (orb_buffer.current_packet_type())
      {
      case PACKET_UNKNOWN :
        Serial.print("U\n");
        break;
      case PACKET_BALLDATA :
        Serial.print("O " );
        break;
      case PACKET_BUTTONDATA :
        Serial.print("B " );
        break;
      default :
        Serial.print(" ERR\n" );
      }
      print_orb_status();
      //print_buffer_axes();
      orb_buffer.log_change();
    }
    //Serial.print("Read\n");
    //if we have something, light pin 13
  }
  //digitalWrite( pin_indicator, LOW);
  //Serial.print(" (");
  //Serial.print(SWval, DEC);
  //Serial.print(")");
  //Serial.print(toupper(SWval));

}
